import os

class GraphicsBlock():
    def __init__(self, name, feature="FEAT_TRAINS"):
        self.name = name
        self.out = []
        self.out.append("item({}, item_{}) {{\n    graphics {{".format(
            feature, self.name))

    def add(self, stuff):
        if stuff == "default":
            self.out.append("        default: spriteset_{}_default;".format(
                self.name))
        if stuff == "articulated_gfx":
            self.out.append(
                "        default: switch_{}_articulated_gfx;".format(
                    self.name))
        if stuff == "purchase":
            self.out.append(
                "        purchase: spriteset_{}_purchase;".format(
                    self.name))

    def __str__(self):
        self.out.append("    }\n}")
        return '\n'.join(self.out)

def switch(name, var, stuff, enumerator=None, feature="FEAT_TRAINS"):
    if not enumerator:
        enumerator = range(len(stuff))
    out = []
    out.append("switch ({}, SELF, switch_{}, {}) {{".format(
        feature, name, var))
    for i, s in zip(enumerator, stuff):
        out.append("    {}: {};".format(i, s))
    out.append("}")
    return '\n'.join(out)

class Spriteset():
    realsprites_purchase = [176, 0, 64, 16, -30, -12]
    def __init__(self, name, source, layout="8_views", l=8):
        self.name = "spriteset_" + name
        self.source = os.path.join("build", source)
        self.out = []
        realsprites_first_4_views = [
            [0,            0, 8,            24, -3,            -12],
            [9 + (8-l)*2,  0, 22 - (8-l)*2, 20, -14 + (8-l)*2, -12],
            [32 + (8-l)*4, 0, 32 - (8-l)*4, 16, -16 + (8-l)*4, -12],
            [65 + (8-l)*2, 0, 22 - (8-l)*2, 20, -6 + (8-l)*2,  -12]
        ]
        realsprites_last_4_views = [
            [88,           0, 8,            24, -3,            -12],
            [97,           0, 22 - (8-l)*2, 20, -14,           -12],
            [120,          0, 32 - (8-l)*4, 16, -16,           -12],
            [153,          0, 22 - (8-l)*2, 20, -6,            -12]
        ]
        self.out.append('spriteset ({}, "{}") {{'.format(
            self.name, self.source))
        if layout != "purchase":
            for i in realsprites_first_4_views:
                self.out.append("    {}".format(repr(i)))
            if layout == "8_views":
                for i in realsprites_last_4_views:
                    self.out.append("    {}".format(repr(i)))
        elif layout == "purchase":
            self.out.append("    {}".format(self.realsprites_purchase))
    def __str__(self):
        self.out.append("}")
        return '\n'.join(self.out)
