#!/usr/bin/env python3

import csv
import os
import sys

import vehicle

project_name = 'its'

build = sys.argv[1]
gfx_src = sys.argv[2]
src_csv_paths = sys.argv[3:]

with open(os.path.join(build, project_name + '.gfxdep'), 'w') as gfx, \
     open(os.path.join(build, project_name + '.pylang'), 'w') as lang, \
     open(os.path.join(build, project_name + '.pynml'), 'w') as nml:
    for csv_file in src_csv_paths:
        with open(csv_file) as c:
            reader = csv.DictReader(c)
            for veh in reader:
                # Ignore rows with empty name cell
                if not veh["name"]:
                    continue
                else:
                    print("[PYTHON3] parsing {}".format(veh["name"]))
                    train = vehicle.Vehicle(veh)
                    gfx.write(train.get_gfx_deps(
                        build, gfx_src, csv_file) + '\n\n')
                    lang.write(train.get_lang() + '\n')
                    nml.write(train.get_nml() + '\n\n')
